' This is file SDL2_image.bi.
'
' FreeBasic-Header file for libSDL2_image (version 2.0.0),
' translated with help of h_2_bi.bas
'
' Licence:
' (C) 2013 Thomas{dOt]Freiherr{ aT }gmx[ DoT }net
'
' This library binding is free software; you can redistribute it
' and/or modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2 of the License, or (at your option) ANY later version.
'
' This library binding is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
' Lesser General Public License for more details, refer to:
' http://www.gnu.org/licenses/lgpl.html
'
' Original licence text
'/*
  'SDL_image:  An example image loading library for use with SDL
  'Copyright (C) 1997-2013 Sam Lantinga <slouken@libsdl.org>

  'This software is provided 'as-is', without any express or implied
  'warranty.  In no event will the authors be held liable for any damages
  'arising from the use of this software.

  'Permission is granted to anyone to use this software for any purpose,
  'including commercial applications, and to alter it and redistribute it
  'freely, subject to the following restrictions:

  '1. The origin of this software must not be misrepresented; you must not
     'claim that you wrote the original software. If you use this software
     'in a product, an acknowledgment in the product documentation would be
     'appreciated but is not required.
  '2. Altered source versions must be plainly marked as such, and must not be
     'misrepresented as being the original software.
  '3. This notice may not be removed or altered from any source distribution.
'*/

#IFDEF __FB_WIN32__
#PRAGMA push(msbitfields)
#ENDIF

#INCLUDE ONCE "SDL2/SDL2.bi"
#INCLIB "SDL2_image" ' place the name of your lib into quotes

EXTERN "C" ' (h_2_bi -P_oCD option)

#IFNDEF _SDL_IMAGE_H
#DEFINE _SDL_IMAGE_H

#DEFINE SDL_IMAGE_MAJOR_VERSION 2
#DEFINE SDL_IMAGE_MINOR_VERSION 0
#DEFINE SDL_IMAGE_PATCHLEVEL 0

#DEFINE SDL_IMAGE_VERSION(X) _
    (X)->major = SDL_IMAGE_MAJOR_VERSION : _
    (X)->minor = SDL_IMAGE_MINOR_VERSION : _
    (X)->patch = SDL_IMAGE_PATCHLEVEL

DECLARE FUNCTION IMG_Linked_Version() AS CONST SDL_version PTR

ENUM IMG_InitFlags
	IMG_INIT_JPG = &h00000001
	IMG_INIT_PNG = &h00000002
	IMG_INIT_TIF = &h00000004
	IMG_INIT_WEBP = &h00000008
END ENUM

DECLARE FUNCTION IMG_Init(BYVAL AS INTEGER) AS INTEGER
DECLARE SUB IMG_Quit()
DECLARE FUNCTION IMG_LoadTyped_RW(BYVAL AS SDL_RWops PTR, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_Load(BYVAL AS CONST ZSTRING PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_Load_RW(BYVAL AS SDL_RWops PTR, BYVAL AS INTEGER) AS SDL_Surface PTR

#IF SDL_VERSION_ATLEAST(2,0,0)

DECLARE FUNCTION IMG_LoadTexture(BYVAL AS SDL_Renderer PTR, BYVAL AS CONST ZSTRING PTR) AS SDL_Texture PTR
DECLARE FUNCTION IMG_LoadTexture_RW(BYVAL AS SDL_Renderer PTR, BYVAL AS SDL_RWops PTR, BYVAL AS INTEGER) AS SDL_Texture PTR
DECLARE FUNCTION IMG_LoadTextureTyped_RW(BYVAL AS SDL_Renderer PTR, BYVAL AS SDL_RWops PTR, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR) AS SDL_Texture PTR

#ENDIF ' SDL_VERSION_ATL...

DECLARE FUNCTION IMG_isICO(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isCUR(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isBMP(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isGIF(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isJPG(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isLBM(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isPCX(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isPNG(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isPNM(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isTIF(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isXCF(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isXPM(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isXV(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_isWEBP(BYVAL AS SDL_RWops PTR) AS INTEGER
DECLARE FUNCTION IMG_LoadICO_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadCUR_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadBMP_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadGIF_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadJPG_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadLBM_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadPCX_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadPNG_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadPNM_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadTGA_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadTIF_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadXCF_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadXPM_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadXV_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_LoadWEBP_RW(BYVAL AS SDL_RWops PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_ReadXPMFromArray(BYVAL AS ZSTRING PTR PTR) AS SDL_Surface PTR
DECLARE FUNCTION IMG_SavePNG(BYVAL AS SDL_Surface PTR, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION IMG_SavePNG_RW(BYVAL AS SDL_Surface PTR, BYVAL AS SDL_RWops PTR, BYVAL AS INTEGER) AS INTEGER

#DEFINE IMG_SetError SDL_SetError
#DEFINE IMG_GetError SDL_GetError

#ENDIF ' _SDL_IMAGE_H

END EXTERN ' (h_2_bi -P_oCD option)

#IFDEF __FB_WIN32__
#PRAGMA pop(msbitfields)
#ENDIF

' Translated at 13-11-08 19:57:32, by h_2_bi (version 0.2.4,
' released under GPLv3 by Thomas[ dot ]Freiherr{ at }gmx[ dot ]net)

'   Protocol: SDL2_image-2.0.0.bi
' Parameters:
'                                  Process time [s]: 0.01616106100846082
'                                  Bytes translated: 4487
'                                      Maximum deep: 1
'                                SUB/FUNCTION names: 41
'                                mangled TYPE names: 0
'                                        files done: 1
' SDL2_image-2.0.0/SDL_image.h
'                                      files missed: 4
' SDL.h
' SDL_version.h
' begin_code.h
' close_code.h
'                                       __FOLDERS__: 1
' SDL2_image-2.0.0/
'                                        __MACROS__: 3
' 42: #define extern
' 41: #define SDLCALL
' 41: #define DECLSPEC
'                                       __HEADERS__: 0
'                                         __TYPES__: 0
'                                     __POST_REPS__: 0
